#include "stdafx.h"
#include "traytest.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define WM_TRAYNOTIFY WM_USER + 100


IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_HAPPY, OnHappy)
	ON_UPDATE_COMMAND_UI(ID_HAPPY, OnUpdateHappy)
	ON_COMMAND(ID_SAD, OnSad)
	ON_UPDATE_COMMAND_UI(ID_SAD, OnUpdateSad)
	//}}AFX_MSG_MAP
  ON_MESSAGE(WM_TRAYNOTIFY, OnTrayNotification)
END_MESSAGE_MAP()


CMainFrame::CMainFrame()
{
  m_bHappy = TRUE;
}


CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_TrayIcon.Create(this, IDR_TRAYPOPUP, "Demo Tray Application", AfxGetApp()->LoadIcon(IDR_HAPPY), WM_TRAYNOTIFY))
  {
    AfxMessageBox("Failed to create tray icon", MB_OK | MB_ICONSTOP);
    return -1;
  }

	return 0;
}


LRESULT CMainFrame::OnTrayNotification(WPARAM wParam, LPARAM lParam)
{
  //Delegate all the work back to the default implementation in
  //CTrayNotifyIcon.
  return m_TrayIcon.OnTrayNotification(wParam, lParam);
}


void CMainFrame::OnHappy() 
{
	m_bHappy = !m_bHappy;

  if (m_bHappy)
  {
    m_TrayIcon.SetIcon(AfxGetApp()->LoadIcon(IDR_HAPPY));
    m_TrayIcon.SetTooltipText("I'm Happy!");
  }
  else
  {
    m_TrayIcon.SetIcon(AfxGetApp()->LoadIcon(IDR_SAD));
    m_TrayIcon.SetTooltipText("I'm Sad!");
  }
}

void CMainFrame::OnUpdateHappy(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_bHappy);
}

void CMainFrame::OnSad() 
{
	OnHappy();
}

void CMainFrame::OnUpdateSad(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(!m_bHappy);
}
